#include <stdexcept>

// ũ⸦ ڷκ Է¹޴´.
template <typename T, int MAXSIZE = 20>
class Stack
{
private:
	T elems[MAXSIZE];
	int cntElems;

public:
	Stack();
	void push(T const&);
	void pop();
	T top() const;
	bool empty() const
	{
		return 0 == cntElems;
	}
	bool full() const
	{
		return cntElems == MAXSIZE;
	}
};

template <typename T, int MAXSIZE>
Stack<T,MAXSIZE>::Stack()
: cntElems(0)
{}

template <typename T, int MAXSIZE>
void Stack<T,MAXSIZE>::push(T const& elem)
{
	if(full())
		throw std::out_of_range("push");
	
	elems[cntElems++] = elem;
}

template <typename T, int MAXSIZE>
void Stack<T,MAXSIZE>::pop()
{
	if(empty())
		throw std::out_of_range("pop");
	
	--cntElems;
}

template <typename T, int MAXSIZE>
T Stack<T,MAXSIZE>::top() const
{
	if(empty())
		throw std::out_of_range("pop");

	return elems[cntElems-1];
}

